import java.util.ArrayList;
import java.util.Scanner;

public class TaskC {
    static int[] p;
    static int n;
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        n = scanner.nextInt();
        int m = scanner.nextInt();
        p = new int[n-1];
        for(int i = 0; i < n-1; i++){
            p[i] = scanner.nextInt() - 2;
        }
        System.out.println(2*(m-1)*dfs(-1, 1) + maxPath());
    }

    static int dfs(int a, int h){
        int max = h;
        if(curMax < h){
            curMax = h;
            curFarest = a;
        }
        for(int i = a+1; i < n-1; i++){
            if(p[i] == a){
                max = Math.max(max, dfs(i, h + 1));
            }
        }
        return max;
    }

    static int curMax, curFarest;
    static int[] newP;

    static int maxPath(){
        newP = new int[n-1];
        ArrayList<Integer> queue = new ArrayList<>();
        ArrayList<Integer> cheked = new ArrayList<>();
        queue.add(curFarest);
        int i = -1;
        while(!queue.isEmpty()){
            if(queue.get(0)!=-1&&!queue.contains(p[queue.get(0)])&&!cheked.contains(p[queue.get(0)])) {
                queue.add(p[queue.get(0)]);
                newP[queue.size() + cheked.size() - 2] = i;
            }
            for(int j = queue.get(0)+1; j < n-1; j++){
                if(p[j] == queue.get(0) && !queue.contains(j)&&!cheked.contains(j)){
                    queue.add(j);
                    newP[queue.size() + cheked.size() - 2] = i;
                }
            }
            i++;
            cheked.add(queue.get(0));
            queue.remove(0);
        }
        return newdfs(-1, 1);
    }

    static int newdfs(int a, int h){
        int max = h;
        for(int i = a+1; i < n-1; i++){
            if(newP[i] == a){
                max = Math.max(max, newdfs(i, h + 1));
            }
        }
        return max;
    }
}
