import java.util.ArrayList;
import java.util.Scanner;
import java.util.TreeSet;

public class TaskC {
    static ArrayList<TreeSet<Integer>> p;
    static int n;
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        n = scanner.nextInt();
        int m = scanner.nextInt();
        p = new ArrayList<>();
        int j;
        p.add(new TreeSet<>());
        for(int i = 1; i < n; i++){
            p.add(new TreeSet<>());
            j = scanner.nextInt()-1;
            p.get(i).add(j);
            p.get(j).add(i);
        }
//        System.out.println(p);
        System.out.println(2*(m-1)*dfs(0, 1) + maxPath());
    }

    static ArrayList<Integer> checked = new ArrayList<>();

    static int dfs(int a, int h){
        checked.add(a);
        if(curMax < h){
            curFarest = a;
            curMax = h;
        }
        int max = h;
        for(Integer b : p.get(a)){
            if(!checked.contains(b)){
                max = Math.max(max, dfs(b, h + 1));
            }
        }
        return max;
    }

    static int curMax, curFarest;

    static int maxPath(){
        checked.clear();
        return(dfs(curFarest, 1));
    }
}
